import { StorageAdapter } from '..'

interface AsyncStorage {
  getItem: (key: string) => Promise<string | null>
  setItem: (key: string, value: string) => Promise<void>
}
interface AsyncStorageConfig {
  storage: AsyncStorage
  serialize?: (value: any) => string
  deserialize?: (value: string) => any
}
/**
 * Generic `AsyncStorage` adapter factory
 */
declare function asyncStorage({
  storage,
  serialize,
  deserialize,
}: AsyncStorageConfig): StorageAdapter

export { AsyncStorage, AsyncStorageConfig, asyncStorage }
